
module Foreign.IO where

open import Data.String

postulate
  IO : Set -> Set
  bindIO : {A B : Set} -> IO A -> (A -> IO B) -> IO B
  returnIO : {A : Set} -> A -> IO A
  ioError : {A : Set} -> String -> IO A

{-# COMPILED bindIO (\_ _ -> (>>=) :: IO a -> (a -> IO b) -> IO b) #-}
{-# COMPILED returnIO (\_ -> return :: a -> IO a) #-}
{-# COMPILED ioError (\_ -> error #-}